/* eslint-disable camelcase */
const UserModel = require('../../../models/UserModel')
const jwt = require('jsonwebtoken')

const setConversation = async (req, res, next) => {
  try {
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')
    const { bio, conversation_projects } = req.body
    if (!bio || conversation_projects === undefined) {
      return res.status(422).json({
        error: true,
        message: 'اطلاعات ارسالی اشتباه است'
      })
    }
    // جستجوی کاربر با شماره موبایل ارسالی
    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const user = await UserModel.findById(decodedToken.id)
    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربری با این شماره موبایل یافت نشد'
      })
    }

    user.bio = bio
    user.conversation_projects = conversation_projects
    await user.save()

    return res.json({
      message: 'روابط عمومی با موفقیت به‌روزرسانی شد'
    })
  } catch (error) {
    next(error)
  }
}
const updateConversation = async (req, res, next) => {
  try {
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')

    const { bio, conversation_projects } = req.body

    if (!bio || conversation_projects === undefined) {
      return res.status(422).json({
        error: true,
        message: 'اطلاعات ارسالی اشتباه است'
      })
    }

    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const userId = decodedToken.id
    // جستجوی کاربر با استفاده از شناسه کاربر
    const user = await UserModel.findById(userId)
    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربری با این شناسه یافت نشد'
      })
    }
    user.bio = bio
    user.conversation_projects = conversation_projects
    await user.save()

    return res.json({
      message: 'روابط عمومی با موفقیت به‌روزرسانی شد'
    })
  } catch (error) {
    next(error)
  }
}
module.exports = {
  setConversation, updateConversation
}
